/************************************************
    RCU6093WB.h

    (c) 2022 Suwa-Koubou
*************************************************/

#ifndef __RCU6093WB__
#define __RCU6093WB__

/*-----------------------------------------------
    definition
-----------------------------------------------*/

#define lcd_RESET   LATBbits.LATB5
#define lcd_SCLK    LATBbits.LATB3
#define lcd_SCEB    LATBbits.LATB2
#define lcd_DC_B    LATBbits.LATB1
#define lcd_SDIN    LATBbits.LATB0

#define  fDATA      1
#define  fCMD       0

#define  gON        1
#define  gOFF       0

// RCU6093W
#define BASIC_INSTRUCTION    0x20
#define EXTENDED_INSTRUCTION 0x21
#define DISPLAY_ALL_WHITE    0x08
#define DISPLAY_ALL_BLACK    0x09
#define DISPLAY_NORMAL       0x0C
#define DISPLAY_INVERT       0x0D
#define Y_ADDRESS_0SET       0x40
#define X_ADDRESS_0SET       0x80

/*-----------------------------------------------
    global variable
-----------------------------------------------*/


/*-----------------------------------------------
    function prototype
-----------------------------------------------*/

extern void lcd_test(void);

extern void lcd_init(void);
extern void lcd_write(char data, int DC_flg);
extern void lcd_clear(void);
extern void lcd_all_black(void);
extern void lcd_all_white(void);
extern void lcd_locate(int row, int col);

extern void lcd_putstr(int row, int col, unsigned char *str);
extern void convert_font8x8(unsigned char data[], const unsigned char font[]);

extern void lcd_putlstr(int row, int col, unsigned char *str);
extern void convert_largefont(unsigned short data[], const unsigned char font[]);

extern void lcd_putnum(int row, int col, unsigned char *str);
extern void convert_font16x16(unsigned short data[], const unsigned short font[]);


extern void glcd_pset(int x, int y, int flg);
extern void glcd_clear(void);
extern void glcd_line(int xBegin, int yBegin, int xEnd, int yEnd, int flg);
extern void glcd_screen(int flg);

#endif

/*** end of RCU6093W.h **************************/
