/************************************************************
    debug.h
    debug print macro
************************************************************/

#ifndef __DEBUG_H_
#define __DEBUG_H_

#define  DEBUG
#define  USEUART1   // refer debug.h

// to PC, UART communication macros
#ifdef DEBUG
  #if defined(USEUART1)
    #define   putstr(x)      UART1PrintString(x)
    #define   puthex(x)      UART1PutHex(x)
    #define   putword(x)     UART1PutHexWord(x)
    #define   putdword(x)    UART1PutHexDWord(x)
    #define   putch(x)       UART1PutChar(x)
    #define   putdec(x)      UART1PutDec(x)
    #define   putcrlf()      putstr("\r\n")
  #elif defined(USEUART2)
    #define   putstr(x)      UART2PrintString(x)
    #define   puthex(x)      UART2PutHex(x)
    #define   putword(x)     UART2PutHexWord(x)
    #define   putdword(x)    UART2PutHexDWord(x)
    #define   putch(x)       UART2PutChar(x)
    #define   putdec(x)      UART2PutDec(x)
    #define   putcrlf()      putstr("\r\n")
  #else
    #error  not define UART 
  #endif
#else
    #define   putstr(x)
    #define   puthex(x)
    #define   putword(x)
    #define   putdword(x)
    #define   putch(x)
    #define   putdec(x)
    #define   putcrlf()
#endif

#endif

/*** end of debug.h *****************************************/
