/*****************************************************************
    ds3231.h
*****************************************************************/

#ifndef _DS3231_H
#define _DS3231_H

// rtc device address
#define RTCDEVADR   0xD0

// register address
#define RTCSEC           0    // 00-59
#define RTCMIN           1    // 00-59
#define RTCHOUR          2    // 00-23 AM/PM+01-12
#define RTCWDAY          3    // 1 - 7
#define RTCDATE          4    // 01-31
#define RTCMONTH         5    // 01-12 Century
#define RTCYEAR          6    // 00-99
#define RTCAL1SEC        7
#define RTCAL1MIN        8
#define RTCAL1HOUR       9
#define RTCAL1WDAYDATE   10   // 0A
#define RTCAL2MIN        11   // 0B
#define RTCAL2HOUR       12   // 0C
#define RTCAL2WDAYDATE   13   // 0D
#define RTCCONTRL        14   // 0E 
#define RTCSTATUS        15   // 0F
#define RTCAGING         16   // 10
#define RTCTEMPHIGH      17   // 11
#define RTCTEMPLOW       18   // 12


#define tm_SEC      0
#define tm_MIN      1
#define tm_HOUR     2
#define tm_WDAY     3
#define tm_DATE     4
#define tm_MONTH    5
#define tm_YEAR     6

// rtcc handling
extern  void    rtcInit(void);
extern  void    rtcWriteTime(unsigned char tm[]);
extern  void    rtcReadTime(unsigned char tm[]);
extern  void    rtcReadNowTime(unsigned char tm[]);
extern  void    rtcReadStatus(unsigned char *status);
extern  void    rtcReadTemp(unsigned char temp[]);
extern  void    rtc_test(void);

// I2C handling
extern  void    i2cOpenStart(void);
extern  void    i2cReStart(void);
extern  void    i2cStopClose(void);
extern  int i2cSend(unsigned char data);
extern  unsigned char   i2cRec(void);
extern  void    i2cAckSend(void);
extern  void    i2cNAckSend(void);

#endif

/*** end of ds3231.h *******************************************/
