/***************************************************************************

    File: key.c

    Copyright (C) 2012 S.Suwa <www.suwa-koubou.jp>

    PIC32MX230F064B use RB13-RB15 three pins.

***************************************************************************/

/** INCLUDES **************************************************************/

#include "HardwareProfile.h"
#include "pic_delay.h"
#include "key.h"
#include "tskchg.h"

#include "debug.h"

#define KeyRaw  ((~PORTB) & 0b1110000000000000)    // mask RB13-RB15


/*--------------------------------------------------------------
    getkey()
--------------------------------------------------------------*/

int     getkey(void)
{
    int key, now_key;

    // L[ĂȂ΁AɃL[Ŗ߂
    if((now_key = KeyRaw) == KEY_NONE) return KEY_NONE;

    // `^OXLbv
    tsk_delay(50);
    if(now_key != KeyRaw){
        return KEY_NONE;
    }

    key = now_key;

    do{
        // L[܂wait
        // ŐV̏ԂŖ߂
        while((now_key = KeyRaw) != KEY_NONE){
            key |= now_key;
            tsk_chg(0);
        }
        tsk_delay(50);
    } while(KeyRaw != KEY_NONE);

    return key;
}


/*** end of key.c *********************************************************/
