/***************************************************************

    timer.h
     for Application timer
     timer value, unit 1 msec
   
   2022.2.3 Support function callback
 
    (c) 2013 Suwa-Koubou
***************************************************************/

#ifndef _TIMER_H
#define _TIMER_H

#define MAX_TIMER    15

#define tmrREPEAT    1
#define tmrONESHOT   0

#define lock_timer()    IEC0bits.T1IE=0     // disable T1 interrupt
#define unlock_timer()  IEC0bits.T1IE=1     // enable T1 interrupt


void    timer_init(void);
int     timer_entry(unsigned int tm_val, int rpt_flg, void (*fn)(void));
void    timer_update(int tmr_id, unsigned int tm_val);
void    timer_delete(int tmr_id);
int     timer_check(int tmr_id);
int     timer_Up(int tmr_id);

#endif
/*** end of timer.h ******************************************/
