/***************************************************************

    tskchg.h

    2013/6/23 S.Suwa  http://www.suwa-koubou.jp
    2019/1/6  add tsk_delay() service

    2021/12/31 support multitasking
***************************************************************/

#ifndef _TSK_CHG_
#define _TSK_CHG_

#define TSK_MAX         5

#define TSK_DELAY       2
#define TSK_EXIST       1
#define TSK_NOEXIST     0

#define TSK_SUSPEND     0
#define TSK_READY       1
#define TSK_RUNNING     2
#define TSK_WAITING     3
#define TSK_RESUME      4

#define TSK_FULL       -1
#define TSK_PRM_ERR    -2
#define TSK_NO_MEMO    -3

#define STKSZ   2560 // task stack size, unit bytes 
                     // need RAM size, 4096bytes * (TSK_MAX-1)

typedef struct {
} TCB;



extern void tsk_init(void);
extern int  tsk_entry(void (*tsk)(void), int priority, int stack_size);
extern void tsk_chg(int tsk_id);
extern void tsk_exit(void);
extern void tsk_delete(int tsk_id);
extern void tsk_delay(int wait); // task is delayed wait ms.
extern void tsk_wait_check(void); // this function user don't call, only called by timer interrupt routine.

#endif
/*** end of tskchg.h ******************************************/
